

public class DocumentExperiment {

    public DocumentExperiment() {}


    public static void experiment(DocumentCanvas D) {
	String S="experiment mode";

	S=S+"\n\n This selection activates the experiment mode.  The experiment mode has two options, single and group.  The single and group modes each have 3 options.  You can read mode about these modes by selecting the experiment mode and then and clicking on the question boxes on the control panels which appear.";

	S=S+"\n\nThe experiment mode performs non-rigorous floating point operations, but it does give a good sense of what is going on.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }


    public static void single(DocumentCanvas D) {
	String S="experiment - single mode";

	S=S+"\n\n This selection activates the single mode of the experiment. In this mode, you select a simplex S using the simplex manager.  The program then chooses random points in S and makes the given test. The program runs until it reaches a point where the test fails. If this does not occur for a long time, this is decent evidence that the given test passes on all of S.";

	S=S+"\n\nOf course, one needs to define what one means by 'a long time'.  I noticed that sometimes it takes about 20 million trials before the program files a failure.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }


    public static void group(DocumentCanvas D) {
	String S="experiment - group mode";

	S=S+"\n\n This selection activates the group mode of the experiment. The group mode works exclusively with the 48-simplex partition.  In this mode, the program then starts out with the complete list LIST of 48 simplices.  The program then randomly cycles through the simplices on LIST, doing the given test on random points.  If the program reaches a failure, it removes the given simplex from the list.";

	S=S+"\n\nInitially, the program colors all the squares on the simplex manager blue. Then, when some simplex is crossed off LIST, the corresponding square is colored black. If you run the program for a long time, then the remaining blue squares very likely pass the test.";


        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }


    public static void test1(DocumentCanvas D) {
	String S="experiment - first test";

	S=S+"\n\n This selection specifies the first of 3 possible tests.  At each point, this tests the implication\n\nf\u22650 \u21D2 df\u22650\n\nHere f is the Cayley-Menger determinant, and df is the directional derivative of f, in the direction specified by the function manager. Geometrically, this is testing whether increasing the lengths of the selected edges increases the volume.  This test ignores points in the given simplex which have f<0.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }

    public static void test2(DocumentCanvas D) {
	String S="experiment - second test";

	S=S+"\n\n This selection specifies the second of 3 possible tests.  At each point, this tests whether P \u22650.  Here P is the polynomial specified by the function manager.  That is, P=(a)f+(b)df, where f is the Cayley-Menger determinant, and df is the directional derivative of f in the direction specified by the function manager.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }


    public static void test3(DocumentCanvas D) {
	String S="experiment - plot";

	S=S+"\n\n This plots the points (f,df) for in the simplex you select on the selection manager.  Here df is the directional derivative you choose using the function manager.";

	S=S+"\n\nPLOT WINDOW CONTROLS:";

	S=S+"\n\nAfter selecting a simplex and a function, select the plot mode and then press 'go' to make the plot";

	S=S+"\n\nred arrow keys: choose the base-2 log of the number of points plotted.";

	S=S+"\n\nLeft mouse click (or else the 'z'-key): zoom in to the picture.";

	S=S+"\n\nMiddle mouse click (or else the 'x'-key): restore the original scale of the picture.";

	S=S+"\n\nRight mouse click (or else the 'c'-key): zoom out of the picture.";

	S=S+"\n\nThe 'f'-key: fit the plot to the screen.";

	S=S+"\n\nAny other key press clears the plot.";



	S=S+"\n\nPLOT DETAILS:";

	S=S+"\n\nWe plot 3 things.  In blue, we plot the line segments which connect the images of the vertices under the map.  These blue lines are not part of the image of the simplex number the map.  However, they serve as guidelines to the picture, so to speak.  We plot in yellow the images of the edges of the simplex under the map. This is, of course, part of the plot.  Then we choose 10000 points at random, biasing the sample so that it lies in the boundary of the simplex. We plot these points in orange.";

	S=S+"\n\nA nice way to use this option is to first run the first test (in group mode). This will select the favorable simplices.  They will remain blue throuthout the running of the test.  Then you can halt the first test and run the plotter, comparing the picture in the selected simplices and in the rejected ones.  In the selected simplices you will see that the image lies in a cone.  In the rejected simplices, the plot goes all over the place.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }






}