

public class DocumentSimplex {

    public DocumentSimplex() {}


    public static void main(DocumentCanvas D) {
	String S="simplex manager";

	S=S+"\n\nThis control panel lets you choose one or more simplices to study.  The total space in question is the space X of normalized pseudo-tetrahedra.  A pseudo-tetrahedron is a labeling of the complete graph K4 by non-negative numbers such that the labels around each 3-cycle satisfy the triangle inequality.  The pseudo-tetrahedra are normalized to have total sum 24.";

	S=S+"\n\nCONTROLS:";

	S=S+"\n\nmouse click: select simplex.";

	S=S+"\n\nkey '1': mark simplex for testing (turns square blue)";

	S=S+"\n\nkey '0': unmark simplex  (turns square black)";

	S=S+"\n\nkey 's': mark all simplices for testing (turns all blue).";

	S=S+"\n\nkey 'i': on a green square (denoting a simplex which has been passed by the positive dominance algorithm) this will tell how many steps the algorithm took.";

	S=S+"\n\nany other key press: clear all markings on the simplex selector.";

	S=S+"\n\nNATURE OF THE TRIANGULATIONS";

	S=S+"\n\nThe space X has 4 separate triangulations.  These triangulations respectively have 3,4,12,48 simplices.  Using the control panel, you can select one of these triangulations.   The 12-triangulation is the common refinement of the 3-triangulation and the 4-triangulation.  The 48-triangulation is a refinement of the 12-triangulation, in which each simplex has been divided into 4 smaller ones.  You can learn about the meaning of the triangulations by clicking on the question boxes in the control panel.";

	S=S+"\n\nThe main triangulation is the 48-simplex triangulation.  Some  of the features of the program, such as the group experiment mode, work exclusively with this triangulation.  However, you can run the single modes of everything on the simplices of any of the triangulations. Also, the 48-simplex triangulation is defined in terms of the other triangulations, so it seems worth keeping the other triangulations around for study.";

	S=S+"\n\nOnce you select a triangulation, you can select a simplex by clicking on one of the black squares which appear.  When you click on the black square, a white square appears in it.";  

	S=S+"\n\nSIMPLEX INFORMATION";


	S=S+"\n\nOnce you click on a selection square, several things happen.  First, the vertices of the simplex are printed out at the bottom of the control panel.  Second, the graph in the function manager is decorated according to the following scheme:";

	S=S+"\n\nThe program picks a random point in the simplex and then (implicitly) labels the edges of the graph. At each vertex, we compute the sums of the labels of the edges incident to that vertex.  We then size the disks surrounding the vertices according to the rank of these sums.  The smallest sum gets the smallest disk, etc.";

S=S+"\n\nFor each pair of opposite edges, we compute the sum of the labels.  This gives us 3 sums.  We rank these sums and then decorate the graph as follows.  The pair of edges with the largest sum is sheathed in thick cyan bands.  One of the edges of pair with the middle sum is shethed in medium width red bands. The remaining edges are unsheathed.";

S=S+"\n\nIt is important to note that the decoration depends on the random point chosen and not just on the simplex chosen. However, if you click repeatedly on the same square, you can see which parts of the decoration changes and which one does not.  The whole point of the 48-simplex triangulation is that the combinatorial features of the decoration do not change within the same simplex.";

S=S+"\n\nCERTIFY MODE";

S=S+"\n\nWhen you run the program in certify mode, the program will color the marked squares green or red according to whether the selected function passes the test on the simplex corresponding to the square.  If you move the cursor over a green square and press 'i', the program will print out the number of steps the algorithm took on this particular input.  This feature only works if you are running the program in the presence of a command line, so that the program has somewhere to print.";

S=S+"\n\nTHE AUXILIARY PARTITION";

S=S+"\n\nThere is one more feature of this interface.  The vertices of each simplex S come in a certain order, and this order determines the polynomial map F from [0,1]^5 to S.  The 6x6 square in the lower left corner determines a partition.  By clicking on the partition, you can change the ordering of the vertices, and thereby change the polynomial function used.  I added this feature because I thought that perhaps sometimes the program would run better in some cases with a changed ordering.  So far, I haven't really experimented much with this.";


        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }



    public static void simplex3(DocumentCanvas D) {
	String S="3 simplex partition";

S=S+"\n\nRecall that our total space X is the space of normalized pseudo-tetrahedra.  A pseudo-tetrahedron is a labeling of the complete graph K4 by non-negative numbers such that the labels around each 3-cycle satisfy the triangle inequality.  The pseudo-tetrahedra are normalized to have total sum 24.";

S=S+"\n\nFor each pair of opposite edges, we compute the sum of the labels.  This gives us 3 sums, corresponding to the edge pairs\n\nP1=(01)(23)\nP2=(02)(13)\nP3=(03)(12)\n\n.  Simplex k in this partition consists of those points such that P_k has the biggest sum.";

S=S+"\n\nThe vertices of these simplices consist of totally degenerate tetrahedra.  In each simplex, 4 of the vertices correspond to configurations where 2 of the vertices coincide and 3 of the vertices correspond to configurations where the points coincide in pairs.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }


    public static void simplex4(DocumentCanvas D) {
	String S="4 simplex partition";

S=S+"\n\nRecall that our total space X is the space of normalized pseudo-tetrahedra.  A pseudo-tetrahedron is a labeling of the complete graph K4 by non-negative numbers such that the labels around each 3-cycle satisfy the triangle inequality.  The pseudo-tetrahedra are normalized to have total sum 24.";

S=S+"\n\nFor vertex of K4, we compute the sum of the labels of the edges incident to that vertex.  This gives us 4 sums.  Simplex k in this partition consists of those points where the kth sum is smallest.";

S=S+"\n\nThe vertices of these simplices consist of totally degenerate tetrahedra.  In each simplex, 3 of the vertices correspond to configurations where 3 of the vertices coincide and 3 of the vertices correspond to configurations where the points coincide in pairs.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }

    public static void simplex12(DocumentCanvas D) {
	String S="12 simplex partition";

S=S+"\n\nRecall that our total space X is the space of normalized pseudo-tetrahedra.  A pseudo-tetrahedron is a labeling of the complete graph K4 by non-negative numbers such that the labels around each 3-cycle satisfy the triangle inequality.  The pseudo-tetrahedra are normalized to have total sum 24.";

S=S+"\n\nThis partition is the common refinement of the 3-partition and the 4-partition. So, each simplex in this partition is the intersection of a simplex from the 3-partition and a simplex from the 4-partition.  Thus, each simplex consists of those points where some particular vertex sum is smallest and some particular opposite-edge sum is largest.";

S="\n\nThe order 12 even permutation group A4 acts on the space X by permuting the labels.  By construction A4 freely and transitively permutes the simplices in the 12-simplex partition.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }

    public static void simplex48(DocumentCanvas D) {
	String S="48 simplex partition";

S=S+"\n\nRecall that our total space X is the space of normalized pseudo-tetrahedra.  A pseudo-tetrahedron is a labeling of the complete graph K4 by non-negative numbers such that the labels around each 3-cycle satisfy the triangle inequality.  The pseudo-tetrahedra are normalized to have total sum 24.";

S=S+"\n\nThe 48-simplex partition is a refinement of the 12-simplex partition, in such a way that each simplex in the 12-simplex partition is divided symmetrically into 4 smaller simplices.  We will describe this partition in terms of the 6x8 grid of squares that controls it.";

S=S+"\n\nEach of the 6 rows of the grid corresponds to those simplices where there is a fixed ordering on the 3 opposite edge sums.  For instance, the top row corresponds to the ordering\n\n(02)(13)\n(03)(12)\n(01)(23).  You can learn the full list of possibilities by clicking on these squares and watching the decoration of the complete graph.";

S=S+"\n\nWe can further decorate K4 along the following lines.  Looking at the two opposite edges with the longest edge-sum, we consider the edge which is not involved in the shortest vertex sum.  Call this the canonical edge.  The canonical edge has two endpoints.  we define the canonical vertex to be the endpoint of the canonical edge with smaller vertex sum.  In the program, the canonical vertex is colored blue.  Furthermore, of the two opposite edges with the middle sum, we unsheath the one which is incident to the canonical vertex. For instance, '3' is the canonical vertex for all the tetrahedra corresponding to the top left square in the 48-simplex selector.";

S=S+"\n\nSuppose we fix a row of the 12-simplex selector, which corresponds to two consecutive rows in the 48-simplex selector.  Within the same column of this row, the canonical vertex does not change.  When we move from one column to the next the canonical vertex changes.  This will make more sense if you click around on the 48-simplex selector and watch the canonical vertex carefully.";

S=S+"\n\nIn other words, we get the 48-partition from the 12-partition by specifying two additional bits of information: the ordering of the pairs of edges with smallest and middle edge-sums, and the location of the canonical vertex on the canoncal edge.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }


}
