import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;

public class Permutation {
    ListenSquare[][] L=new ListenSquare[6][6];
    int[][] on=new int[6][6];
    int x,y;
    int count;

    public Permutation(int x,int y,int c) {
      this.x=x;
      this.y=y;
      this.count=c;
      for(int i=0;i<count;++i) {
        for(int j=0;j<count;++j) {
          L[i][j]=new ListenSquare(x+14*i,y+14*j,12,12,null);
          L[i][j].on=1;
	  on[i][j]=0;
	  if(i==j) on[i][j]=1;

	}
      }
    }

    public void render(Graphics g,Color C) {
	for(int i=0;i<count;++i) {
	for(int j=0;j<count;++j) {
	    if(on[i][j]==1) L[i][j].render(g,new Color(255,150,0));
	    if(on[i][j]==0) L[i][j].render(g,C);
	}}
    }

    public void process(Point X) {
	for(int i=0;i<count;++i) {
	    for(int j=0;j<count;++j) {
		if(L[i][j].inside(X)==1) change(i,j);
	    }
	}
    }

    public void change(int i,int j) {
	int ii=-1;
	int jj=-1;
	if(on[i][j]==1) return;
	for(int k=0;k<count;++k) {
	    if(on[i][k]==1) jj=k;
	    if(on[k][j]==1) ii=k;
	}
	on[i][j]=1;
	on[i][jj]=0;
	on[ii][j]=0;
	on[ii][jj]=1;
    }

    public int[] getPermutation() {
	int[] a=new int[count];
	for(int i=0;i<count;++i) {
	    for(int j=0;j<count;++j) {
		if(on[i][j]==1) a[i]=j;
	    }
	}
	return(a);
    }

    public int[] permuteList(int[] a) {
	int[] b=new int[a.length];
	int[] p=getPermutation();
	for(int i=0;i<a.length;++i) {
	    b[i]=a[p[i]];
	}
	return(b);
    }


    public void printPermutation() {
	int[] a=getPermutation();
	for(int i=0;i<a.length;++i) {
	    System.out.print(a[i]);
	}
	System.out.println("");
    }
}
